from asdl import asdl_ as asdl
from asdl import const  # For const.NO_INTEGER
from asdl import runtime
from pylib import unpickle

from core import util

f = util.GetResourceLoader().open('_devbuild/runtime_asdl.pickle')
TYPE_LOOKUP = unpickle.load_v2_subset(f)
f.close()

class part_value_e(object):
  String = 1
  Array = 2

class part_value(runtime.CompoundObj):
  ASDL_TYPE = TYPE_LOOKUP['part_value']

class part_value__String(part_value):
  tag = 1
  ASDL_TYPE = TYPE_LOOKUP['part_value__String']
  __slots__ = ('s', 'do_split_glob', 'spids')

  def __init__(self, s=None, do_split_glob=None, spids=None):
    self.s = s
    self.do_split_glob = do_split_glob
    self.spids = spids or []

class part_value__Array(part_value):
  tag = 2
  ASDL_TYPE = TYPE_LOOKUP['part_value__Array']
  __slots__ = ('strs', 'spids')

  def __init__(self, strs=None, spids=None):
    self.strs = strs or []
    self.spids = spids or []

part_value.String = part_value__String
part_value.Array = part_value__Array

class value_e(object):
  Undef = 1
  Str = 2
  StrArray = 3
  AssocArray = 4

class value(runtime.CompoundObj):
  ASDL_TYPE = TYPE_LOOKUP['value']

class value__Undef(value):
  ASDL_TYPE = TYPE_LOOKUP['value__Undef']
  tag = 1

class value__Str(value):
  tag = 2
  ASDL_TYPE = TYPE_LOOKUP['value__Str']
  __slots__ = ('s', 'spids')

  def __init__(self, s=None, spids=None):
    self.s = s
    self.spids = spids or []

class value__StrArray(value):
  tag = 3
  ASDL_TYPE = TYPE_LOOKUP['value__StrArray']
  __slots__ = ('strs', 'spids')

  def __init__(self, strs=None, spids=None):
    self.strs = strs or []
    self.spids = spids or []

class value__AssocArray(value):
  tag = 4
  ASDL_TYPE = TYPE_LOOKUP['value__AssocArray']
  __slots__ = ('d', 'spids')

  def __init__(self, d=None, spids=None):
    self.d = d
    self.spids = spids or []

value.Undef = value__Undef
value.Str = value__Str
value.StrArray = value__StrArray
value.AssocArray = value__AssocArray

class cell(runtime.CompoundObj):
  ASDL_TYPE = TYPE_LOOKUP['cell']
  __slots__ = ('val', 'exported', 'readonly', 'is_assoc_array', 'spids')

  def __init__(self, val=None, exported=None, readonly=None,
               is_assoc_array=None, spids=None):
    self.val = val
    self.exported = exported
    self.readonly = readonly
    self.is_assoc_array = is_assoc_array
    self.spids = spids or []

class var_flags_e(runtime.SimpleObj):
  ASDL_TYPE = TYPE_LOOKUP['var_flags']

var_flags_e.Exported = var_flags_e(1, 'Exported')
var_flags_e.ReadOnly = var_flags_e(2, 'ReadOnly')
var_flags_e.AssocArray = var_flags_e(3, 'AssocArray')
var_flags_e.Global = var_flags_e(4, 'Global')

class scope_e(runtime.SimpleObj):
  ASDL_TYPE = TYPE_LOOKUP['scope']

scope_e.TempEnv = scope_e(1, 'TempEnv')
scope_e.LocalOnly = scope_e(2, 'LocalOnly')
scope_e.GlobalOnly = scope_e(3, 'GlobalOnly')
scope_e.Dynamic = scope_e(4, 'Dynamic')

class lvalue_e(object):
  LhsName = 1
  LhsIndexedName = 2

class lvalue(runtime.CompoundObj):
  ASDL_TYPE = TYPE_LOOKUP['lvalue']

class lvalue__LhsName(lvalue):
  tag = 1
  ASDL_TYPE = TYPE_LOOKUP['lvalue__LhsName']
  __slots__ = ('name', 'spids')

  def __init__(self, name=None, spids=None):
    self.name = name
    self.spids = spids or []

class lvalue__LhsIndexedName(lvalue):
  tag = 2
  ASDL_TYPE = TYPE_LOOKUP['lvalue__LhsIndexedName']
  __slots__ = ('name', 'index', 'spids')

  def __init__(self, name=None, index=None, spids=None):
    self.name = name
    self.index = index
    self.spids = spids or []

lvalue.LhsName = lvalue__LhsName
lvalue.LhsIndexedName = lvalue__LhsIndexedName

class redirect_e(object):
  PathRedirect = 1
  DescRedirect = 2
  HereRedirect = 3

class redirect(runtime.CompoundObj):
  ASDL_TYPE = TYPE_LOOKUP['redirect']

class redirect__PathRedirect(redirect):
  tag = 1
  ASDL_TYPE = TYPE_LOOKUP['redirect__PathRedirect']
  __slots__ = ('op_id', 'fd', 'filename', 'spids')

  def __init__(self, op_id=None, fd=None, filename=None, spids=None):
    self.op_id = op_id
    self.fd = fd
    self.filename = filename
    self.spids = spids or []

class redirect__DescRedirect(redirect):
  tag = 2
  ASDL_TYPE = TYPE_LOOKUP['redirect__DescRedirect']
  __slots__ = ('op_id', 'fd', 'target_fd', 'spids')

  def __init__(self, op_id=None, fd=None, target_fd=None, spids=None):
    self.op_id = op_id
    self.fd = fd
    self.target_fd = target_fd
    self.spids = spids or []

class redirect__HereRedirect(redirect):
  tag = 3
  ASDL_TYPE = TYPE_LOOKUP['redirect__HereRedirect']
  __slots__ = ('fd', 'body', 'spids')

  def __init__(self, fd=None, body=None, spids=None):
    self.fd = fd
    self.body = body
    self.spids = spids or []

redirect.PathRedirect = redirect__PathRedirect
redirect.DescRedirect = redirect__DescRedirect
redirect.HereRedirect = redirect__HereRedirect

class job_status_e(object):
  ProcessStatus = 1
  PipelineStatus = 2

class job_status(runtime.CompoundObj):
  ASDL_TYPE = TYPE_LOOKUP['job_status']

class job_status__ProcessStatus(job_status):
  tag = 1
  ASDL_TYPE = TYPE_LOOKUP['job_status__ProcessStatus']
  __slots__ = ('status', 'spids')

  def __init__(self, status=None, spids=None):
    self.status = status
    self.spids = spids or []

class job_status__PipelineStatus(job_status):
  tag = 2
  ASDL_TYPE = TYPE_LOOKUP['job_status__PipelineStatus']
  __slots__ = ('statuses', 'spids')

  def __init__(self, statuses=None, spids=None):
    self.statuses = statuses or []
    self.spids = spids or []

job_status.ProcessStatus = job_status__ProcessStatus
job_status.PipelineStatus = job_status__PipelineStatus

class span_e(runtime.SimpleObj):
  ASDL_TYPE = TYPE_LOOKUP['span']

span_e.Black = span_e(1, 'Black')
span_e.Delim = span_e(2, 'Delim')
span_e.Backslash = span_e(3, 'Backslash')

class emit_e(runtime.SimpleObj):
  ASDL_TYPE = TYPE_LOOKUP['emit']

emit_e.Part = emit_e(1, 'Part')
emit_e.Delim = emit_e(2, 'Delim')
emit_e.Empty = emit_e(3, 'Empty')
emit_e.Escape = emit_e(4, 'Escape')
emit_e.Nothing = emit_e(5, 'Nothing')

class state_e(runtime.SimpleObj):
  ASDL_TYPE = TYPE_LOOKUP['state']

state_e.Invalid = state_e(1, 'Invalid')
state_e.Start = state_e(2, 'Start')
state_e.DE_White1 = state_e(3, 'DE_White1')
state_e.DE_Gray = state_e(4, 'DE_Gray')
state_e.DE_White2 = state_e(5, 'DE_White2')
state_e.Black = state_e(6, 'Black')
state_e.Backslash = state_e(7, 'Backslash')

class char_kind_e(runtime.SimpleObj):
  ASDL_TYPE = TYPE_LOOKUP['char_kind']

char_kind_e.DE_White = char_kind_e(1, 'DE_White')
char_kind_e.DE_Gray = char_kind_e(2, 'DE_Gray')
char_kind_e.Black = char_kind_e(3, 'Black')
char_kind_e.Backslash = char_kind_e(4, 'Backslash')

class builtin_e(runtime.SimpleObj):
  ASDL_TYPE = TYPE_LOOKUP['builtin']

builtin_e.NONE = builtin_e(1, 'NONE')
builtin_e.READ = builtin_e(2, 'READ')
builtin_e.ECHO = builtin_e(3, 'ECHO')
builtin_e.PRINTF = builtin_e(4, 'PRINTF')
builtin_e.SHIFT = builtin_e(5, 'SHIFT')
builtin_e.CD = builtin_e(6, 'CD')
builtin_e.PUSHD = builtin_e(7, 'PUSHD')
builtin_e.POPD = builtin_e(8, 'POPD')
builtin_e.DIRS = builtin_e(9, 'DIRS')
builtin_e.EXPORT = builtin_e(10, 'EXPORT')
builtin_e.UNSET = builtin_e(11, 'UNSET')
builtin_e.SET = builtin_e(12, 'SET')
builtin_e.SHOPT = builtin_e(13, 'SHOPT')
builtin_e.TRAP = builtin_e(14, 'TRAP')
builtin_e.UMASK = builtin_e(15, 'UMASK')
builtin_e.SOURCE = builtin_e(16, 'SOURCE')
builtin_e.DOT = builtin_e(17, 'DOT')
builtin_e.EVAL = builtin_e(18, 'EVAL')
builtin_e.EXEC = builtin_e(19, 'EXEC')
builtin_e.WAIT = builtin_e(20, 'WAIT')
builtin_e.JOBS = builtin_e(21, 'JOBS')
builtin_e.COMPLETE = builtin_e(22, 'COMPLETE')
builtin_e.COMPGEN = builtin_e(23, 'COMPGEN')
builtin_e.COMPOPT = builtin_e(24, 'COMPOPT')
builtin_e.TRUE = builtin_e(25, 'TRUE')
builtin_e.FALSE = builtin_e(26, 'FALSE')
builtin_e.COLON = builtin_e(27, 'COLON')
builtin_e.TEST = builtin_e(28, 'TEST')
builtin_e.BRACKET = builtin_e(29, 'BRACKET')
builtin_e.GETOPTS = builtin_e(30, 'GETOPTS')
builtin_e.COMMAND = builtin_e(31, 'COMMAND')
builtin_e.TYPE = builtin_e(32, 'TYPE')
builtin_e.HELP = builtin_e(33, 'HELP')
builtin_e.DECLARE = builtin_e(34, 'DECLARE')
builtin_e.TYPESET = builtin_e(35, 'TYPESET')
builtin_e.ALIAS = builtin_e(36, 'ALIAS')
builtin_e.UNALIAS = builtin_e(37, 'UNALIAS')
builtin_e.PWD = builtin_e(38, 'PWD')
builtin_e.REPR = builtin_e(39, 'REPR')

class effect_e(runtime.SimpleObj):
  ASDL_TYPE = TYPE_LOOKUP['effect']

effect_e.SpliceParts = effect_e(1, 'SpliceParts')
effect_e.Error = effect_e(2, 'Error')
effect_e.SpliceAndAssign = effect_e(3, 'SpliceAndAssign')
effect_e.NoOp = effect_e(4, 'NoOp')

class process_state_e(runtime.SimpleObj):
  ASDL_TYPE = TYPE_LOOKUP['process_state']

process_state_e.Init = process_state_e(1, 'Init')
process_state_e.Done = process_state_e(2, 'Done')

class completion_state_e(runtime.SimpleObj):
  ASDL_TYPE = TYPE_LOOKUP['completion_state']

completion_state_e.NONE = completion_state_e(1, 'NONE')
completion_state_e.FIRST = completion_state_e(2, 'FIRST')
completion_state_e.REST = completion_state_e(3, 'REST')
completion_state_e.VAR_NAME = completion_state_e(4, 'VAR_NAME')
completion_state_e.HASH_KEY = completion_state_e(5, 'HASH_KEY')
completion_state_e.REDIR_FILENAME = completion_state_e(6, 'REDIR_FILENAME')

class word_style_e(runtime.SimpleObj):
  ASDL_TYPE = TYPE_LOOKUP['word_style']

word_style_e.Expr = word_style_e(1, 'Expr')
word_style_e.Unquoted = word_style_e(2, 'Unquoted')
word_style_e.DQ = word_style_e(3, 'DQ')
word_style_e.SQ = word_style_e(4, 'SQ')

